/**********************************************************************

	--- Qt Architect generated file ---

	File: GfCurveWin.cpp
	Last generated: Mon Jul 5 10:39:57 1999

 *********************************************************************/

#include "GfCurveWin.h"
#include <string.h>
#include "../gfcommon.h"

#define Inherited GfCurveWinData

GfCurveWin::GfCurveWin
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
	setCaption( "Curve Format" );
	
	// private so it is never used
}

GfCurveWin::GfCurveWin
(
	GfFile *gff
)
	:
	Inherited( NULL, NULL )
{
	setCaption( "Curve Format" );
	
	gffile = gff;
	
	init();
}

void GfCurveWin::init()
{
int numc,i;
char temp[50];

	dvalid = new QDoubleValidator(10,.1,6,this);

	numc = gffile->numCurves();
	
	if(numc == 0)
	{
		curvenumber_combobox->setEnabled(FALSE);
		linewidth_combobox->setEnabled(FALSE);
		linetype_combobox->setEnabled(FALSE);
		patternlength_lineedit->setEnabled(FALSE);
		color_combobox->setEnabled(FALSE);
		apply_button->setEnabled(FALSE);
	}
	else
	{
		curvenumber_combobox->setEnabled(TRUE);
		linewidth_combobox->setEnabled(TRUE);
		linetype_combobox->setEnabled(TRUE);
		patternlength_lineedit->setEnabled(TRUE);
		color_combobox->setEnabled(TRUE);
		apply_button->setEnabled(TRUE);
	}
	
	for(i=0;i<NUM_PSCOLORS;i++)
	{
		color_combobox->insertItem(pscolors[i]);
	}
	
	for(i=0;i<NUM_PSLINETYPES;i++)
	{
		linetype_combobox->insertItem(psdash[i]);
	}		

	for(i=0;i<NUM_PSLINEWIDTHS;i++)
	{
		linewidth_combobox->insertItem(pswidths[i]);
	}		

	patternlength_lineedit->setValidator(dvalid);
	
	if(numc > MAX_CURVES) numc = MAX_CURVES;

	for(i=0;i<numc;i++)
	{
		sprintf(temp,"%i",i+1);
		curvenumber_combobox->insertItem(temp);
	}
	
	if(numc > 0)
	{
		curvenumber_combobox->setCurrentItem(0);
	
		setCurve(0);
	}
}

GfCurveWin::~GfCurveWin()
{
	delete dvalid;
}

void GfCurveWin::dismissButton()
{
	done(0);
}

void GfCurveWin::applyButton()
{
int nc;

	nc = curvenumber_combobox->currentItem();

	gffile->setCurveColor(nc,color_combobox->currentItem());
	gffile->setCurveLineType(nc,linetype_combobox->currentItem());
	gffile->setCurveLineWidth(nc,linewidth_combobox->currentItem());
	
	gffile->setCurvePatternLength(nc,atof(patternlength_lineedit->text()));
	
	emit curveChanged();

}

void GfCurveWin::setCurve(int )
{
int nc;
char text[20];

	nc = curvenumber_combobox->currentItem();

	color_combobox->setCurrentItem(gffile->curveColor(nc));
	linetype_combobox->setCurrentItem(gffile->curveLineType(nc));
	linewidth_combobox->setCurrentItem(gffile->curveLineWidth(nc));

	sprintf(text,"%g",gffile->curvePatternLength(nc));	
	patternlength_lineedit->setText(text);

}

