/**********************************************************************

	--- Qt Architect generated file ---

	File: GfDataTransWin.cpp
	Last generated: Thu Jul 15 21:35:23 1999

 *********************************************************************/

#include "GfDataTransWin.h"

#define Inherited GfDataTransWinData

GfDataTransWin::GfDataTransWin
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
	setCaption( "Data Transformations" );
}

GfDataTransWin::GfDataTransWin
(
	GfFile *gff
)
	:
	Inherited( NULL, NULL )
{
	setCaption( "Data Transformations" );
	
	gffile = gff;
	
	gffile_saved = NULL;
	
	init();
}

void GfDataTransWin::init()
{
char text[50];

	setCurves();

	allcurves_checkbox->setChecked(TRUE);
	
	allCurves();
	
	// the order of the following must not be changed
	
	strcpy(text,"X=A*X+B*Y+C; Y=D*X+E*Y+F");
	operation_combobox->insertItem(text);
	
	strcpy(text,"Reduce Number of Points");
	operation_combobox->insertItem(text);
	
	strcpy(text,"Data Smoothing");
	operation_combobox->insertItem(text);

	strcpy(text,"Remove Curve");
	operation_combobox->insertItem(text);
	
	strcpy(text,"Linear Fit");
	operation_combobox->insertItem(text);
	
	// end ordered
	
	operation_combobox->setCurrentItem(0);
	
	operationSelected(0);
	
	dvalid = new QDoubleValidator(1.e36,-1.e36,6,this,NULL);
	
	a_lineedit->setValidator(dvalid);
	a_lineedit->setText("1.0");
	b_lineedit->setValidator(dvalid);
	b_lineedit->setText("0.0");
	c_lineedit->setValidator(dvalid);
	c_lineedit->setText("0.0");
	d_lineedit->setValidator(dvalid);
	d_lineedit->setText("0.0");
	e_lineedit->setValidator(dvalid);
	e_lineedit->setText("1.0");
	f_lineedit->setValidator(dvalid);
	f_lineedit->setText("0.0");
	
	undo_button->setEnabled(FALSE);
	
}

void GfDataTransWin::setCurves()
{
int i,nc;
char text[20];

	nc = gffile->numCurves();
	
	curvenumber_combobox->clear();
	
	if( nc > 0)
	{
		for(i=0;i < nc;i++)
		{
			sprintf(text,"%i",i+1);
			curvenumber_combobox->insertItem(text);
		}
	}
	else
	{
		apply_button->setEnabled(FALSE);
	}

}

GfDataTransWin::~GfDataTransWin()
{

	if(gffile_saved != NULL)
		delete gffile_saved;
		
	delete dvalid;
}


void GfDataTransWin::allCurves()
{
	if(allcurves_checkbox->isChecked() == TRUE)
	{
		curvenumber_combobox->setEnabled(FALSE);
		curvenumber_label->setEnabled(FALSE);
	}
	else
	{
		curvenumber_combobox->setEnabled(TRUE);
		curvenumber_label->setEnabled(TRUE);
	}

}

void GfDataTransWin::operationSelected(int op)
{
	a_label->hide();
	a_lineedit->hide();
	b_label->hide();
	b_lineedit->hide();
	c_label->hide();
	c_lineedit->hide();
	d_label->hide();
	d_lineedit->hide();
	e_label->hide();
	e_lineedit->hide();
	f_label->hide();
	f_lineedit->hide();
			
	reduce_label->hide();
	smooth_label->hide();
	int_spinbox->hide();
	
	allcurves_checkbox->setEnabled(TRUE);
	
	append_checkbox->show();
	
	linfit_label->hide();
	
	if(gffile->numCurves() > 0)
		apply_button->setEnabled(TRUE);
	else
		apply_button->setEnabled(FALSE);
		
	switch(op)
	{
		case 0: // linear trans
		
			a_label->show();
			a_lineedit->show();
			b_label->show();
			b_lineedit->show();
			c_label->show();
			c_lineedit->show();
			d_label->show();
			d_lineedit->show();
			e_label->show();
			e_lineedit->show();
			f_label->show();
			f_lineedit->show();
				
		break;
		
		case 1: //reduce data point
		
			reduce_label->show();
			int_spinbox->show();
			int_spinbox->setRange(2,99);		
			int_spinbox->setValue(2);
		
		break;
		
		case 2: //data smoothing
		
			smooth_label->show();
			int_spinbox->show();
			int_spinbox->setRange(1,99);		
			int_spinbox->setValue(1);
						
		break;
				
		case 3: // delete curve
		
			allcurves_checkbox->setChecked(FALSE);
			allcurves_checkbox->setEnabled(FALSE);
			append_checkbox->hide();
				
		break;
		
		case 4:  // info label on linear fit
		
			linfit_label->show();
			apply_button->setEnabled(FALSE);
		
		default:
		break;

	}
	
	allCurves();
}

void GfDataTransWin::applyButton()
{
float a,b,c,d,e,f;
int n,append,curve,op,i,nc;
GfCurve new_c;

	a=b=c=d=e=f=0.;
	n = 0;

	op = operation_combobox->currentItem();
	
	undo_button->setEnabled(TRUE);
	
	if(gffile_saved == NULL)
		gffile_saved = new GfFile(gffile);
	else
		*(gffile_saved) = *(gffile);

	if(append_checkbox->isChecked() == TRUE)
	{
		append = GF_YES;
	}
	else
	{
		append = GF_NO;
	}
	
	if(allcurves_checkbox->isChecked() == TRUE)
	{
		curve = -1;
	}
	else
	{
		curve = curvenumber_combobox->currentItem();
	}
	
	switch(op)
	{
		case 0: // linear trans
		
			a=atof(a_lineedit->text());
			b=atof(b_lineedit->text());
			c=atof(c_lineedit->text());
			d=atof(d_lineedit->text());
			e=atof(e_lineedit->text());
			f=atof(f_lineedit->text());
			
		
		break;
		
		case 1: //reduce data point
		
			n = atoi(int_spinbox->text());
		
		break;
		
		case 2: //data smoothing
		
			n = atoi(int_spinbox->text());
						
		break;
		
		
		case 3: // delete curve
									
		break;
		
		default:
		break;
	
	}
	
	if(curve < 0) // do all curves
	{	
		nc = gffile->numCurves();
		for(i=0;i < nc;i++)
		{
			new_c = gffile->curve(i);
			switch(op)
			{
				case 0:
					new_c.linearTransform(a,b,c,d,e,f);
				break;
				case 1:
					new_c.reduceNumberPoints(n);
				break;
				case 2:
					new_c.smooth(n);
				break;
				case 3:
					// don't have this choice
					
				break;
				default:
				break;
				
			}
			if(append == GF_NO)
			{
				gffile->setCurve(i,new_c);
			}
			else
			{
				gffile->appendCurve(new_c);
			}
		}
	}
	else
	{
		new_c = gffile->curve(curve);				
		switch(op)
		{
			case 0:
				new_c.linearTransform(a,b,c,d,e,f);
				if(append == GF_NO)
				{
					gffile->setCurve(curve,new_c);
				}
				else
				{
					gffile->appendCurve(new_c);
				}
			break;
			case 1:
				new_c.reduceNumberPoints(n);
				if(append == GF_NO)
				{
					gffile->setCurve(curve,new_c);
				}
				else
				{
					gffile->appendCurve(new_c);
				}
			break;
			case 2:
				new_c.smooth(n);
				if(append == GF_NO)
				{
					gffile->setCurve(curve,new_c);
				}
				else
				{
					gffile->appendCurve(new_c);
				}
			break;
			case 3:
				gffile->removeCurve(curve);
					
			break;
			default:
			break;
				
		}
	}
		
	emit dataChanged();	
			
	setCurves();		
	
	if(curve > 0 && op != 3)
	{
		curvenumber_combobox->setCurrentItem(curve);
	}
		
}

void GfDataTransWin::dismissButton()
{
	done(0);
}

void GfDataTransWin::undoButton()
{
	if(gffile_saved != NULL)
	{
	
		*(gffile) = *(gffile_saved);
		
		emit dataChanged();
	
		delete gffile_saved;
		gffile_saved = NULL;
		
		undo_button->setEnabled(FALSE);
		
		setCurves();
	}
}
