/*

    This code is part of Gf which is free software.
    See the file COPYING for more details.

    Copyright (C) 1999  T. W. Shield, shield@aem.umn.edu
    
    
    NOTES:
    	
	symbol still has line type problem (screen only)
	
	need page label on PS output (done)
	
	need proper font support on screen (done)
	
	pdef is not getting plot name set.
	
	
	this should be reimpltemented as an absract class with
	each type of display as an derived class.
	
	
*/
#include "gfdraw.h"
#include "qdatetime.h"
#include "gfutil.h"


GfDraw::GfDraw()
{
#ifdef DEBUG1
	cout << "construct gfdraw\n";
#endif
	
	device = DEV_NONE;
    
	fonts_used = NULL;
	
	pdef = NULL;
	
	qt_is_printer = FALSE;
}


int GfDraw::initPS(QFile *f, GfPlotDefs *p, GfScale *s)
{
/*

	Call with f = NULL to check plotdefs
	
	
*/
QDateTime date_time;
float sx,sy;

	if(device != DEV_NONE)
		return(GF_BAD);

	device = DEV_PS;
	
	qfile = f;
	
	// keep a pointer for later use
	
	pdef = p;
	
	// these should not be global
	
	currfont = 2;
	
    /* from gfxplot.c */
    
     xl = 1607; xr = 10300; yu = 7650; yb = 1467;  /* hp plotter values */
    
     if(pdef->rotatePlot() == GF_NO)
     {
     	sx = 100. * fabs(pdef->xPlotSize()) * 1016. / ((float)xr - (float)xl);
     	sy = 100. * fabs(pdef->yPlotSize()) * 1016. / ((float)yu - (float)yb);
     }
     else
     {
     	sx = 100. * fabs(pdef->xPlotSize()) * 1016. / ((float)yu - (float)yb);
     	sy = 100. * fabs(pdef->yPlotSize()) * 1016. / ((float)xr - (float)xl);
     }
    
     if( sx < 10. || sx > 100.)
     {
        return(GF_BAD);

     }
     
     if( sy < 10. || sy > 100.)
     {
        return(GF_BAD);

     }
     
     if(f == NULL) return(GF_OK); // just checking plotdefs
     
     scale = s;
	
     // pull out the most commonly used variables.
	
     xmax = scale->xMax();
     ymax = scale->yMax();
     xmin = scale->xMin();
     ymin = scale->yMin();
	
     xr = (int)((float)xl + pdef->xPlotSize() * 1016.);
     yu = (int)((float)yb + pdef->yPlotSize() * 1016.);

     /* from gfxps.c */
     
/*
 	INIT PLOTTER for postscript
*/

float tllx,turx,tlly,tury;
char pp[]="%%";  /* to sprintf %% */
char *title;

     strcpy(pout,"%!PS-Adobe-2.0 EPSF-2.0");
     plot_out(pout); /*  ' postscript start flag */

     if(pdef->rotatePlot() == GF_NO)   /* ' figure out bounding box dimensions  */
     {
             tllx = .5;
             turx = ((float)((int)yu - (int)yb) / 1016.) + 2.5;
             tlly = 10.5 - ((float)((int)xr - (int)xl) / 1016.) - 2.5;
             tury = 10.;
     }
     else
     {
             tllx = .5;
             tlly = .5; /* was 1.0 */
             turx = ((float)((int)xr - (int)xl) / 1016.) + 2.5;
             tury = ((float)((int)yu - (int)yb) / 1016.) + 2.;  /* was + 2.5 */
     }
     
     sprintf(pout,"%sBoundingBox: %i %i %i %i ",pp,(int)(72 * tllx),(int)(72 * tlly),(int)(72 * turx),(int)(72 * tury));
     plot_out(pout);
     
     if( pdef->plotNameLen() > 0)
     {
    	title = (char *)malloc(pdef->plotNameLen()+1);
     	if( title == NULL )
     	{
     		printf("out of memory in gfdraw \n");
		exit(-1);
     	}
     	pdef->plotName(title);
     	sprintf(pout,"%sTitle: %s",pp, title);
     	plot_out(pout);
     }
     else
     {
     	title = "untitled";
     }
     
     strcpy(pout,"%%Creator: GfQt");
     plot_out(pout);
     

     date_time = QDateTime::currentDateTime();

     strcpy(pout, "%%CreationDate: ");
     strcat(pout,date_time.toString());
     plot_out(pout);

     strcpy(pout,"%%EndComments");
     plot_out(pout);

     if(pdef->encapsulated() == GF_NO)    /* don't initmatrix if file is encapsulated */
     {
         strcpy(pout," initmatrix");
         plot_out(pout);
         
         if(pdef->rotatePlot() == GF_YES)  /* label the printout */
         {
         	strcpy(pout,"/Helvetica findfont  [12 0 0 12 0 0] makefont setfont");
         	plot_out(pout);         	
         	sprintf(pout," 30 770 moveto (%s ",title);
         	strcat(pout,date_time.toString());
         	strcat(pout,") show ");
         }
         else
         {
         	strcpy(pout,"/Helvetica findfont  [0 -12 12 0 0 0] makefont setfont");
         	plot_out(pout);         	
         	sprintf(pout," 590 770 moveto (%s ",title);         
         	strcat(pout,date_time.toString());
         	strcat(pout,") show ");         
         }
         plot_out(pout);
     }
     
     if( pdef->plotNameLen() > 0)
     {
		free(title);
     }

      strcpy(pout,"72 72 scale 0.35 10.46 translate -90 rotate ");
      plot_out(pout);

      strcpy(pout," .000984 .000984 scale [ ] 0 setdash");
      plot_out(pout);
      
#ifdef PSTIMEOUT
      if(pdef->encapsulated() == GF_NO)
      {
          strcpy(pout, " statusdict begin /waittimeout 900 def end ");
          plot_out(pout);
      }
#endif

      strcpy(pout," /m {moveto} def /l {lineto} def /s {stroke} def /n {newpath} def ");
      plot_out(pout);

      sprintf(pout," %i setlinejoin ",pdef->psJoin());
      plot_out(pout);

/*
      REM
      REM   DEFINE SYMBOL PROCS
      REM
*/
      strcpy(pout," /square { m -45 -45 rm 90 0 rl 0 90 rl -90 0 rl closepath } def ");  plot_out(pout);
      strcpy(pout," /triangle { m 0 -33 rm 57.7 0 rl -57.7 100 rl -57.7 -100 rl closepath } def ");  plot_out(pout);
      strcpy(pout," /cone { m 0 33 rm -57.7 0 rl 57.7 -100 rl 57.7 100 rl closepath } def ");  plot_out(pout);
      strcpy(pout," /cross { m -45 -45 rm 90 90 rl -90 0 rm 90 -90 rl } def "); plot_out(pout);
      strcpy(pout," /circle { 50 sf mul 0 360 arc } def "); plot_out(pout);

      if( pdef->rotatePlot() == GF_YES )
      {
           strcpy(pout," /rot (Y) def ");  plot_out(pout);
      }
       else
      {
           strcpy(pout," /rot (N) def "); plot_out(pout);
      }
/*
      if( sx > sy)
      {
           t = sx / .75;
      }
      else
      {
           t = sy / .75;
      }
*/

      sprintf(pout," /sf %f def /msf -1 sf mul def ",pdef->symbolSize());  
      plot_out(pout);

      strcpy(pout," /rm { (Y) rot eq { [ 0 sf msf 0 0 0 ] dtransform rmoveto } { [ sf 0 0 sf 0 0 ] dtransform rmoveto } ifelse } def ");  
      plot_out(pout);
      strcpy(pout," /rl { (Y) rot eq { [ 0 sf msf 0 0 0 ] dtransform rlineto } { [ sf 0 0 sf 0 0 ] dtransform rlineto } ifelse } def ");  
      plot_out(pout);

/* define font procs */

        sprintf(pout,"/fheight %f def",200.*pdef->fontSize()); 
	plot_out(pout);
	
/* drops/raises amounts define here */

        strcpy(pout,"/drop 0.25 def"); 
	plot_out(pout);
        strcpy(pout,"/raise 0.6 def"); 
	plot_out(pout);

/* drops/raises for angle of 0 */

        strcpy(pout,"/dropy fheight drop mul def"); plot_out(pout);
        strcpy(pout,"/dropx fheight 0.0 mul def"); plot_out(pout);
        strcpy(pout,"/mdropx dropx -1 mul def"); plot_out(pout);
        strcpy(pout,"/mdropy dropy -1 mul def"); plot_out(pout);
        strcpy(pout,"/raisey fheight raise mul def"); plot_out(pout);
        strcpy(pout,"/mraisey raisey -1 mul def"); plot_out(pout);
        strcpy(pout,"/raisex fheight 0.0 mul def"); plot_out(pout);
        strcpy(pout,"/mraisex raisex -1 mul def"); plot_out(pout);
	
/* size of sub/sup characters */

        strcpy(pout,"/supsub 0.8 def"); plot_out(pout);
        strcpy(pout,"/isupsub 1.0 supsub div def"); plot_out(pout);

        strcpy(pout,"/subshow { currentfont supsub scalefont setfont mdropx mdropy rmoveto "); plot_out(pout);
        strcpy(pout,"show dropx dropy rmoveto currentfont isupsub scalefont setfont} def"); plot_out(pout);

        strcpy(pout,"/supshow { currentfont supsub scalefont setfont raisex raisey rmoveto show "); plot_out(pout);
        strcpy(pout,"mraisex mraisey rmoveto currentfont isupsub scalefont setfont} def"); plot_out(pout);

	return(GF_OK);


}

int GfDraw::initPaint(QPainter *p, int w, int h, GfPlotDefs *pd,GfScale *s)
{

	if( device == DEV_PS )
		return(GF_BAD);
	
	device = DEV_QT;
    
    	painter = p;
    
	xl = (int)( 95*pd->fontSize());
	xr = w-10;
	
	// code assumes yu > yb
	
	yu = h-10;
	yb = 40;
	
	qth = h;
	
	scale = s;
    
	pdef = new GfPlotDefs(pd);
	
	pdef->setRotatePlot(GF_NO);
		
	currfont = 2;
	
	// pull out the most commonly used variables.
	
	xmax = scale->xMax();
	ymax = scale->yMax();
	xmin = scale->xMin();
	ymin = scale->yMin();
		
	pen.setColor(black);
	pen.setStyle(SolidLine);
	pen.setWidth(2);
	
	painter->setPen(pen);
	
	return(GF_OK);

}

int GfDraw::initPaintPrinter(QPainter *p, int w, int h, GfPlotDefs *pd,GfScale *s)
{
	if( device == DEV_PS )
		return(GF_BAD);
	
	device = DEV_QT;
	
	qt_is_printer = TRUE;
    
    	painter = p;
	
	pdef = new GfPlotDefs(pd);
	
	pdef->setRotatePlot(GF_NO);
    
	xl = (w - ((int)(pdef->xPlotSize() * 72.)))/2; // centered
	
	// code assumes yu > yb
	
	yb = (h - ((int)(pdef->yPlotSize() * 72.)))/2; // centered
	
	xr = (int)((float)xl + pdef->xPlotSize() * 72.);
	yu = (int)((float)yb + pdef->yPlotSize() * 72.);

	qth = h;
	
	scale = s;
    		
	currfont = 2;
	
	// pull out the most commonly used variables.
	
	xmax = scale->xMax();
	ymax = scale->yMax();
	xmin = scale->xMin();
	ymin = scale->yMin();
		
	pen.setColor(black);
	pen.setStyle(SolidLine);
	pen.setWidth(2);
	
	painter->setPen(pen);
	
	return(GF_OK);

}

GfDraw::~GfDraw()
{
#ifdef DEBUG1
	cout <<"destroy GfDraw\n";
#endif	

	free(fonts_used);
	
	if(device == DEV_QT)
	{
		delete pdef;
	}

#ifdef DEBUG1
	cout <<"destroy GfDraw done\n";
#endif	

}

// these are private and should never be called

GfDraw::GfDraw(GfDraw &)
{



}
GfDraw::GfDraw(GfDraw *)
{



}

/*****************************************************************

		CURVE SECTION
		
******************************************************************/

void GfDraw::curve(GfCurve *c,int start,int end,int color_change)
{
// this code should still be device independant  it calles line, etc
// which is device dependant.

/*

	start = SEG_WHOLE_CURVE draws whole curve
	
	start = SEG_ONE_POINT puts symbol at point end

	start = SEG_LAST_LINE draws just the last line segment
	
	start,end == valid segment --> draw curve segment with color
		of one plus curve color (for selection)
*/

	if(pdef->curvesVisible() != GF_YES)
		return;
	
/*
3185 REM
3190 REM            PLOT CURVES   modified for plot_form
3195 REM
*/
float xx,yy;
int x,y,xsave,ysave,tp,i,x0,y0,t,os,nc;
char tt[50];
int xy[200];

     setcolor(c->color()+color_change);
     
     linetype(c->lineType(),c->patternLength());
     
     linewidth(c->lineWidth());
     
     nc = c->numPoints();
     
	if(start == SEG_WHOLE_CURVE)
	{
		start = 0;
		end = nc-1;
	}
	if(start == SEG_ONE_POINT)
	{	
		if(device != DEV_QT) return;
			
		if(end > -1 && end < nc) // just draw one point
		{
     			xx = c->pointX(end); 
     			yy = c->pointY(end);
     			x = x_coord(xx);
     			y = y_coord(yy);
			symbol(x,y,2);
		}
		return;
	}
	if(start == SEG_LAST_LINE) // does not work for symbols
	{
		start = nc-2;
		end = nc-1;
	}
	
	if( start < 0 || start >=nc || end <= start || end >= nc) 
	{
		return;
	}

     xx = c->pointX(start); // first pt assumed to have invec == 0
     yy = c->pointY(start);
     x = x_coord(xx);
     y = y_coord(yy);

     xsave = x;  ysave = y;  tp = 0;

for(i = start+1;i <= end;i++)      /* main loop thru the data */
{

     if( c->pointInvec(i) != 1 )
     {
           if(tp > 0)     /* flush the buffer, next pt is not a line pt */
           {
                  t= tp; line(t,xy); tp = 0; 
           }
           goto skip;
      }
      else      /* we have a line point */
      {
           x0 = xsave; y0 = ysave; 
	    
	   x = x_coord( c->pointX(i));  
	   y = y_coord( c->pointY(i));
	   
           if( x == xsave &&  y == ysave)   /* ignore dupilcate pts */
           {
                 continue;
           }
           else
           {
                xsave = x;  ysave = y;
		
                wind(&x0, &y0, &x, &y, &os);  /* check pt is on plot */
		
#ifdef DEBUG1
		//cout << "os 1 = "<<os<<"\n";
#endif		

                if( os == 1)
                {
                      if( tp > 0)   /* next pt off screen, flush */
                      {
                            t = tp; line(t,xy);  tp = 0; 
                      }
                      continue;
                }

                if(tp == 0)    /* first pt */
                {
                      xy[1] = x0; xy[2] = y0;  tp = 1;
                }

                if( os == -1)
                {
                      if(tp > 0)
                      {
                             tp = tp + 1; xy[2 * tp - 1] = x;  xy[2 * tp] = y;
                             t = tp; line(t,xy);  tp = 0; 
                      }
                      continue;
                }

               tp = tp+ 1; xy[2 * tp - 1] = x;  xy[2 * tp] = y;

               if(tp >= 99)
               {
                     t = tp; line(t,xy);  tp = 0;
               }
               continue;
           }
      }
/* line 3290 */

skip:
     if( c->pointInvec(i) <= 0)
     {
              setcolor(-(c->pointInvec(i)));
              x = x_coord( c->pointX(i));  y = y_coord(c->pointY(i));
              xsave = x;  ysave = y;
              continue;
     }
     
     x = x_coord( c->pointX(i));  
     y = y_coord( c->pointY(i));

     os = chkpt(x,y); xsave = x;ysave = y;  /* is symbol on or off the screen? */

#ifdef DEBUG1
	cout << "os = "<<os<<"\n";
#endif	

     if(os == 1) continue;

     if(c->pointInvec(i) > 31)
     {
             currfont  = 2;
             tt[0] = (char)c->pointInvec(i);
             tt[1] = '\0';
             t = 0;  
             text(x, y, tt, t,pdef->fontSize());
     }
     else
     {
            x = x_coord(c->pointX(i));  y = y_coord(c->pointY(i));
            t = c->pointInvec(i) - 1;
            if(t < 10 )
            {
                   symbol(x, y, t);
            }
            else
            {
	    	  x0 = x_coord(c->pointX(i-1));  y0 = y_coord(c->pointY(i-1));
                  if(t==10) draw_arrow(c,i,x,y,x0,y0,0);
                  if(t==11) draw_arrow(c,i,x,y,x0,y0,1); /* filled arrow */
            }
      }


 }      /* next i */

     if(tp > 0)      /* flush the rest of the points in xy[]  */
     {
             t  = tp; line(t,xy);  tp = 0;
     }

}

int GfDraw::x_coord(float x)
{

int xc;
/*
xc = (int)(xl+(xr-xl)*(x-xmin)/(xmax-xmin));
*/
    if( scale->xLogScale() == GF_NO)
    {
           xc=(int)((x - xmin) / (xmax - xmin) * ((float)xr - (float)xl) + (float)xl + .5);
    }
    else
    {
           xc=((int) ((log(x) - log(xmin)) / (log(xmax) - log(xmin)) * ((float)xr - (float)xl) + (float)xl + .5));
    }

return xc;

}

int GfDraw::y_coord(float y)
{

int yc;
/*
yc = (int)((float)yu+((int)yb-(int)yu)*(ymax-y)/(ymax-ymin));
*/

/* changed for ps/hpgl compatibility */

    if(scale->yLogScale() == GF_NO)
    {
    /*    was
          yc=((int)((ymax - y)/ (ymax - ymin) * ((int)yb - (int)yu) + yu + .5) );
    */
          yc=((int)((y - ymin)/ (ymax - ymin) * ((float)yu - (float)yb) + (float)yb + .5) );
    }
    else
    {
    /*   was
          yc=((int)((log(ymax) - log(y)) / (log(ymax) - log(ymin)) * (yb - yu) + yu + .5));
    */
          yc=((int)((log(y) - log(ymin)) / (log(ymax) - log(ymin)) * ((float)yu - (float)yb) + (float)yb + .5));
    }

return yc;

}

void GfDraw::wind (int *x0,int *y0,int  *x ,int  *y,int  *os)
{
/*
1685 REM
1690 REM   CALL THIS WITH (X0,Y0)-(X,Y) TO GET LINE WINDOWED
1695 REM
*/
int u0,v0,u,v,f,xn,yn;

/*   if we use clip box  --- but lets check it works first...
if(device ==  1){ *os = 0; return(0); }
*/

     *os = 0; u0 = *x;  v0 = *y;  u = *x0;  v = *y0;

     endpoint(u0,v0,u,v,&f,&xn,&yn);

     if( f != 0)         /*   THEN 1750  */
     {
        if(xn > (int)xr || xn < (int)xl ||  yn < yb || yn > yu ) *os = 1;
        if(abs(u0 - u) < (abs(u0 - xn) + abs(u - xn))) *os = 1;
        if(abs(v0 - v) < (abs(v0 - yn) + abs(v - yn))) *os = 1;
        if(*os == 1) return; /*               WHOLE LINE OFF SCREEN  */
     }

     u0 = xn; v0 = yn;  u = *x;  v = *y;
     endpoint(u0,v0,u,v,&f,&xn,&yn);

     if(f != 0 ) *os = -1;
     *x0 = u0; *y0 = v0;  *x = xn;  *y = yn;

}


void GfDraw::endpoint(int u0,int v0,int u,int v,int *f,int *xn,int *yn)
{
float m,b;
int sf,t;
/*
1585 REM
1590 REM   CALLED BY wind TO DO EACH END POINT OF A LINE
1595 REM
*/
     *f = 0;

     if( u > (int)xr) { *f = 1;  *xn = xr; }

     if( u < (int)xl) { *f = 1; *xn = xl;}

     if( v > (int)yu) { *f = *f - 2; *yn = yu;}

     if( v < (int)yb) { *f = *f - 2; *yn = yb;}

     if( *f == 0 ) { *xn = u; *yn = v;  return;}

     if(abs(u - u0) > abs(v - v0) )
     {
/* find y = m x + b */
                m = ((float)(v - v0)) /((float) (u - u0));
                b = (float)v - m * (float)u;
                sf = 1 ;
     }
     else
     {
/* find x = m y + b */
                 m = ((float)(u - u0)) / ((float)(v - v0));
                b = (float)u - m * (float)v;
                sf = 0;
     }

     if(*f == 1 && sf == 1 ) { *yn = (int)(m *(float) (*xn) + b); return;}

     if(*f == 1 && sf == 0 && m != 0 ) { *yn = (int)(((float)*xn - b) / m); return;}

     if(*f == -2 && sf == 1 && m != 0 ) { *xn = (int)(((float)*yn - b) / m); return;}

     if(*f == -2 && sf == 0 ) { *xn = (int)(m * (float)(*yn) + b); return;}

     if( sf == 1 )
     {
          t = *yn; *yn = (int)(m * (float)(*xn) + b);

          if( (*yn > (int)yu || *yn < (int)yb) && m != 0 )
          {
             *xn = (int)(((float)t - b) / m);  *yn = t;
          }
     }

     if( sf == 0 )
     {
          t = *xn; *xn = (int)(m * (*yn) + b);

          if( (*xn > (int)xr || *xn < (int)xl) && m != 0 )
          {
               *yn = (int)(((float)t - b) / m);  *xn = t;
          }
     }
}

int GfDraw::chkpt (int xt,int yt)
{
/*
REM
REM             CHECK POINT ON SCREEN
REM
*/
//float x,y;
//int xt,yt;
int os;

/* old version was chkpt(int i)
       x = xp[i];  y = yp[i];

       xt=x_coord(x);
       yt=y_coord(y);
*/
       os=0;
       
       if( xt < (int)xl || xt > (int)xr) os=1;
       if( yt < (int)yb || yt > (int)yu) os=1;

       return(os);

}


void GfDraw::draw_arrow(GfCurve *c,int i,int x, int y,int x0,int y0,int fill)
{
float a,r,theta,a1,r1;
// float x0,y0;
int t,x1,y1;
int xy[9];
float dx,dy;

        a = 25.*3.14159/180.;  /* angle of the arrow head */

        //x0 = xp[i-1];y0=yp[i-1];

        xy[1] = x0; //x_coord(x0);
        xy[2] = y0; //y_coord(y0);

        dx = (c->pointX(i) - c->pointX(i-1))*fabs((float)(xr-xl))/fabs(xmax-xmin);//x - xy[1];
        dy = (c->pointY(i) - c->pointY(i-1))*fabs((float)(yu-yb))/fabs(ymax-ymin);//y - xy[2];

        xy[3] = x; xy[4] = y;
        t=2;
	line(t,xy);

        if(pdef->arrowSize() == 0.)
        {
                r = .2* pdef->fontSize() * sqrt( (x-x0)*(x-x0) + (y-y0)*(y-y0));
        }
        else
        {
                r = pdef->arrowSize()*((float)xr-(float)xl)/30.;
        }

        if( r < 1 ) r = 1;

        theta = 3.14159/2.;
        if (dy < 0.) theta = - theta;
        if (dx != 0.) theta = atan(dy/dx);

        if(dx < 0. ) theta = theta + 3.14159;

        x0 = (int)(x - r *cos(a + theta));
        y0 = (int)(y - r* sin(a + theta));

        xy[1]=x0;
        xy[2]=y0;
        xy[3]=x;
        xy[4]=y;
        t = 4;

        x1 = (int)(x - r*cos(-a+theta));
        y1 = (int)(y - r*sin(-a+theta));

        xy[5]=x1;xy[6]=y1;
        xy[7]=x0;xy[8]=y0;
        line(t,xy);

        if(fill != 0)
        {

/* filled arrow */


        for(a1 = a-a/r/2.; a1>0;a1=a1-a/r/2.)
        {
                r1 = a1/a * r;
                x0 = (int)(x - r1 *cos(a1 + theta));
                y0 = (int)(y - r1* sin(a1 + theta));

                xy[1]=x0;
                xy[2]=y0;
                xy[3]=x;
                xy[4]=y;
                t = 2;
                line(t,xy);

                xy[1]=x;xy[2]=y;t=3;

                x1 = (int)(x - r1*cos(-a1+theta));
                y1 = (int)(y - r1*sin(-a1+theta));

                xy[3]=x1;xy[4]=y1;
                xy[5]=x0;xy[6]=y0;
                line(t,xy);
        }

        }

}


void GfDraw::draw_symbol(int x,int y,int t1,int d)
{
int dd,t,ii;
float pi=3.14159;
int xy[52];

#ifdef DEBUG1
	cout <<"drawing symbol "<<t1<<"\n";
#endif	

	if (t1 == 1 || t1 == 5)
	{
	/* square   */
		dd = d / 2; xy[1] = x - dd;  xy[2] = y - dd;  xy[3] = x + dd;  
		xy[4] = y - dd;  xy[5] = x + dd;  xy[6] = y + dd;
		xy[7] = x - dd; xy[8] = y + dd;  xy[9] = x - dd;  xy[10] = y - dd;  t = 5;   
		line( t,xy);
	}
	if (t1 == 2 || t1 == 6)
	{
	/*    circle  */
		for( ii = 1;ii<=25;ii++)
		{ 
			xy[2 * ii - 1] =(int)( ((float)x) + ((float)d) * cos(2. * pi * (float)(ii - 1) / 24.) / 2.);
			xy[2 * ii] =(int)( ((float)y) + ((float)d) * sin(2. * pi * (float)(ii - 1) / 24.) / 2.);
		}
		t = 25;  line( t, xy);
	}
	if (t1 == 3 || t1 == 7)
	{
	/*   triangle  */
		xy[1] = x; xy[2] = y - d / 3;  xy[3] = x + (d * 577)/1000;  xy[4] = y - d / 3;  xy[5] = x;  xy[6] = y + (2 * d) / 3;
		xy[7] = x - (d *577)/1000; xy[8] = y - d / 3;  xy[9] = x;  xy[10] = y - d / 3;  t = 5;   
		line( t,xy);
	}
	if (t1 == 4 || t1 == 8)
	{
	/*    cone  */
		xy[1] = x; xy[2] = y + d / 3;  xy[3] = x + (d * 577)/1000;  xy[4] = y + d / 3;  xy[5] = x;  xy[6] = y - 2 * d / 3;
		xy[7] = x - (d * 577)/1000; xy[8] = y + d / 3;  xy[9] = x;  xy[10] = y + d / 3;  t = 5;   
		line( t,xy);
	}

	if (t1 > 8)
	{
	/*    cross  */
		dd=d/2; xy[1] = x-dd; xy[2] = y - dd;  xy[3] = x + dd ;  xy[4] = y + dd ;
  		t = 2;   line( t,xy);
  		xy[1] = x-dd; xy[2] = y + dd;  xy[3] = x + dd ;  xy[4] = y - dd ;
  		t = 2;   line( t,xy);

	}
}

/***************************************************************

		COMMENTS SECTION
		
****************************************************************/


void GfDraw::comments(GfComments *c)
{
int i,t,tx,ty;
float row,col,fsize;
char *com;


        if( pdef->commentsVisible() == GF_YES)
        {
               
	       for(i=0;i<c->numComments();i++)
	       {
	       		currfont=c->font(i);
			setcolor(c->color(i));
			fsize = c->fontSize(i);
			
			tx=0;ty=0;
			
			if(c->locationType(i) == LOCATION_ROWCOL)
			{
				row = c->locationY(i);
				col = c->locationX(i);
	                 	tx =(int)( xl + (float)((col - 14)*(xr-xl)) / 67.) ;
          			ty =(int)( yb + (1. - row/20.) * (yu - yb));
			}
			if(c->locationType(i) == LOCATION_DATA)
			{			
	                 	tx = x_coord(c->locationX(i));
          			ty = y_coord(c->locationY(i));
			}
          		t=0;
			
			if(c->commentLen(i) > 0)
			{
				strmalloc(&com,c->commentLen(i));
				c->comment(i,com);
          			text(tx, ty, com,t,fsize);
				free(com);
			}
			
		}

        }

}




/***************************************************************

		AXES SECTION
		
****************************************************************/

void GfDraw::axes()
{
        if(pdef->axesVisible() == GF_YES)
        {
               axes_box();
               show_ticks();
        }



}

void GfDraw::show_ticks()
{
/*
        does x - y axes labels, ticks and numbers

*/
int sgx,sgy;
int x_tick_len,y_tick_len;
int xy[10];
/*

                    PLOT AXES LABELS AND NUMBERS, TICKS/GRIDS

*/

	setcolor(pdef->color());

     	currfont = pdef->font();
		
     	linewidth(LW_DEFAULT);

	linetype(LT_SOLID);
	
	if(device == DEV_QT)
	{
        	titlesQT();     
	}
	
	if(device == DEV_PS)
	{
		titlesPS();     
	}


/*

                    PLOT Y=0 LINES

*/



	if( (ymin*ymax < 0) && scale->yZeroLine() == GF_YES)
	{
   		xy[1]= x_coord(xmin);
   		xy[2]= y_coord(0);
   		xy[3]= x_coord(xmax);
   		xy[4]= y_coord(0);
   		line(2,xy);
	}


/*

                    PLOT X=0 LINES

*/
	if( (xmin*xmax < 0) && scale->xZeroLine() == GF_YES)
	{
   		xy[1]= x_coord(0);
   		xy[2]= y_coord(ymin);
   		xy[3]= x_coord(0);
   		xy[4]= y_coord(ymax);
   		line(2,xy);
	}
	
/*

                    PLOT TICKS/GRIDS

*/
	if( scale->ticksType() == TT_NONE ) return;

	if(scale->ticksType() == TT_TICKS)
	{
     	/* old tx and ty */
     		x_tick_len = ((int)xr - (int)xl) / 58;
     		y_tick_len = (abs((int)yb - (int)yu) / 48) ;  /* should get signs ok */
	}
	else
	{
    		x_tick_len = ((int)xr - (int)xl);
    		y_tick_len = abs((int)yb - (int)yu);  /* grids */
	}

	if (( scale->ticksType() == TT_TICKS) && (device == DEV_PS))
	{
		y_tick_len = x_tick_len;
	}

	sgx = sign(xmin) * sign(xmax);
	sgy = sign(ymin) * sign(ymax);
	
float xtick,ytick;

	xtick = scale->xTicksStep();
	ytick = scale->yTicksStep();

	if(scale->xLogScale() == GF_YES)
	{
		log_ticks(2,xmin,xmax,xtick,x_tick_len,y_tick_len);
	}
	else
	{	
		setup_ticks(xmax,xmin,xtick,2,x_tick_len,y_tick_len);
	}

	if(scale->yLogScale() == GF_YES)
	{
		log_ticks(3,ymin,ymax,ytick,x_tick_len,y_tick_len);
	}
	else
	{
		setup_ticks(ymax,ymin,ytick,3,x_tick_len,y_tick_len);
	}

	if(scale->ticksType() == TT_GRIDS)
	{
             return;
	}

	if(scale->xLogScale() == GF_YES)
	{
		log_ticks(4,xmin,xmax,xtick,x_tick_len,y_tick_len);
	}
	else
	{
		setup_ticks(xmax,xmin,xtick,4,x_tick_len,y_tick_len);
	}

	if(scale->yLogScale() == GF_YES)
	{
		log_ticks(1,ymin,ymax,ytick,x_tick_len,y_tick_len);
	}
	else
	{
		setup_ticks(ymax,ymin,ytick,1,x_tick_len,y_tick_len);
	}


	if( ymin*ymax < 0.0 && scale->yZeroLine() == GF_YES)
	{
         	if(scale->xLogScale() == GF_YES)
         	{
                	log_ticks(7,xmin,xmax,xtick,x_tick_len,y_tick_len);
         	}
         	else
         	{
			setup_ticks(xmax,xmin,xtick,7,x_tick_len,y_tick_len);
         	}
     	}

     	if( xmin*xmax < 0.0 && scale->xZeroLine() == GF_YES)
	{
          	if(scale->yLogScale() == GF_YES)
          	{
			log_ticks(8,ymin,ymax,ytick,x_tick_len,y_tick_len);
          	}
          	else
          	{
			setup_ticks(ymax,ymin,ytick,8,x_tick_len,y_tick_len);
          	}
     	}

}

void GfDraw::titlesPS()
{
float vp;
int tx,ty;
char temp[50],*xlabel,*ylabel;

     	//set_font(0); /* text = 0 is axes labels */
	
	vp = pdef->fontSize();
		
	if(scale->xLabelLen() > 0)
	{
    	 	ty = (int)(yb - 587 * vp);
		strmalloc(&xlabel,scale->xLabelLen());
		scale->xLabel(xlabel);
     		tx = (int)((xr + xl) / 2 - 52 * vp * drawnstrlen(xlabel));
     		text(tx, ty, xlabel, 0,vp);
		free(xlabel);
	}

	if(scale->yLabelLen() > 0)
	{
     		tx = (int)(xl - 482 * vp);
		strmalloc(&ylabel,scale->yLabelLen());
		scale->yLabel(ylabel);
     		ty = (int)((yu + yb) / 2 - 52 * vp * drawnstrlen(ylabel));
     		text(tx, ty, ylabel, 90,vp);
		free(ylabel);
	}


     	convert(temp,ymax);
     	tx = (int)(xl - 161 * vp - 105 * vp * strlen(temp));
     	ty = (int)(yu - 60 + (1 - vp) * 52);
     	text(tx, ty, temp, 0,vp);
		
     	convert(temp,ymin);
     	tx = (int)(xl - 161 * vp - 105 * vp * strlen(temp));
     	ty = (int)(yb - 60 + (1 - vp) * 52);
     	text(tx, ty, temp,0,vp);

     	convert(temp,xmax);
     	ty = (int)(yb - 293 * vp + (1 - vp) * 54);
     	tx = (int)(xr - 52 * vp * (strlen(temp) - 1));
     	text(tx, ty, temp,0,vp);

     	convert(temp,xmin);
     	ty = (int)(yb - 293 * vp + (1 - vp) * 54);
     	tx = (int)(xl - 52 * vp * (strlen(temp) - 1));
     	text(tx, ty, temp, 0,vp);

}

void GfDraw::titlesQT()
{
char data[50];
int x,y,fheight,fwidth;
char *xlabel,*ylabel;
//unsigned int i;
float vp;

	vp = pdef->fontSize();

	setQtFont(currfont,vp); // need metrics back
		
	fheight= painter->fontMetrics().height(); // get these from QT func
	fwidth = painter->fontMetrics().width("c");
		
        x=xl;
        y=qth-(yu-fheight);

        convert(data,ymax);
        x=x-fwidth*strlen(data)-10;
	painter->drawText(x,y,data);
	
        x=xl;
        y=qth-yb -fheight/4;

        convert(data,ymin);
        x=x-fwidth*strlen(data)-10;
	painter->drawText(x,y,data);

        x=xl;
        y=qth-yb + fheight;

        convert(data,xmin);
        x=x-fwidth*strlen(data)/2;
	painter->drawText(x,y,data);
	
        x=xr;
        y=qth-yb + fheight;

        convert(data,xmax);
        x=x-fwidth*strlen(data);
	painter->drawText(x,y,data);
	
        x=(xr+xl)/2;
       	//y=qth-yb+5*fheight/2;
	//y = qth - y;
	
	if(qt_is_printer == TRUE)
	{
		y = yb - 3*fheight;
	}	
	else
	{
		y = yb/2-fheight/2;
	}

        if(y >= qth ) y = qth-fheight;

	if(scale->xLabelLen() > 0)
	{
		strmalloc(&xlabel,scale->xLabelLen());
		scale->xLabel(xlabel);

        	x=x-fwidth*drawnstrlen(xlabel)/2; 
		
		// new part:
		
		text(x, y, xlabel, 0,vp);
		//painter->drawText(x,y,xlabel);
		free(xlabel);
	}

	if(scale->yLabelLen() > 0)
	{
		strmalloc(&ylabel,scale->yLabelLen());
		scale->yLabel(ylabel);

        	//x=xl-5*fwidth;
 		
		if(qt_is_printer == TRUE)
		{
			x = xl - 3*fheight;
		}
		else
		{
			x = xl/2 /* - fheight/2 */;		
		}

		// for on screen rotated text:
		
        	y=(yb+yu)/2-fwidth*drawnstrlen(ylabel,0)/2;
		
 		text(x, y, ylabel, 90,vp);
		/*

        	for(i=0;i<=strlen(ylabel);i++)
       		{
        		sprintf(data,"%c",ylabel[i]);
			painter->drawText(x,y,data);
        		y=y+fheight;
        	}
		*/
		free(ylabel);
	}
}


void GfDraw::axes_box()
{
/*
3525 REM
3530 REM            PLOT BOX WITH PEN #1 SLOW SPEED modified for plot_form
3535 REM
*/
int t,xy[5];

	setcolor(pdef->color());

	linetype(LT_SOLID);
     
	linewidth(LW_BOX);
     
/*
        old single path box -- with setlinejoin changed need
        each line of box separate to get sharp corners

     xy[1] = xl; xy[2] = yb;  xy[3] = xr;  xy[4] = yb;
     xy[5] = xr; xy[6] = yu;  xy[7] = xl;  xy[8] = yu;
     xy[9] = xl; xy[10] = yb;  t = 5;  line(t,xy);
*/


     xy[1] = xl; xy[2] = yb;  xy[3] = xr;  xy[4] = yb;
     t = 2;  line(t,xy);

     xy[1] = xr;  xy[2] = yb; xy[3] = xr; xy[4] = yu;
     t = 2;  line(t,xy);

     xy[1] = xr; xy[2] = yu;  xy[3] = xl;  xy[4] = yu;
     t = 2;  line(t,xy);

     xy[1] = xl;  xy[2] = yu;
     xy[3] = xl; xy[4] = yb;  t = 2;  line(t,xy);

}

void GfDraw::setup_ticks(float max,float min,float step,int type,int x_len,int y_len)
{
	if(max < min)
	{
		float t = max;
		max = min;
		min = t;
	}	
	
	if(min >= 0.0)
	{
		float start = (float)((int)(min/step)-1)*step;
		
		if(start < 0.0) start = 0.0;
		
		lin_ticks(type,start,max,step,x_len,y_len);
		
		return;
	}
	
	if(max <= 0.0)
	{
		float start = (float)((int)(max/step)+1)*step;
		
		if(start > 0.0) start = 0.0;
		
		lin_ticks(type,start,min,-1.*step,x_len,y_len);
		
		return;
	}
	
	lin_ticks(type,0.0,max,step,x_len,y_len);
	lin_ticks(type,0.0,min,-1.*step,x_len,y_len);
}

void GfDraw::lin_ticks(int d,float t,float t1,float t2,int x_len,int y_len)
{
/* 4300 */
float x,y,zz,tt;
int xt,yt,k;

     x=0.;y=0.;
     
     k = 0;  // too many ticks counter
     
     if(fabs(t1) < fabs(t))
     {
     	tt = t1;
	t1 = t;
	t = tt;
	t2 = -t2;
     }
          
     for(zz = t;fabs(zz)<=fabs(t1);zz=zz+t2)
     {

        if( d == 1 ){ y = zz; x = xmin; }
        if( d == 2 ){ x = zz; y = ymin;  }
        if( d == 3 ){ y = zz; x = xmax;  }
        if( d == 4 ){ x = zz; y = ymax;  }
        if( d == 7 ){ x = zz; y = 0.;     }
        if( d == 8 ){ y = zz; x = 0.;     }
	
	if(d == 1 || d == 3 || d == 8)
	{
		if(zz < ymin || zz > ymax) continue;
	}
	else
	{
		if(zz < xmin || zz > xmax) continue;
	}
	

        xt=x_coord(x);
        yt=y_coord(y);

        put_ticks(d,xt,yt,x_len,y_len);   /* 4375 */
	
	k++;
	if(k > 1000) break;
     }
}

void GfDraw::log_ticks(int d,float t1,float t2,float t3,int x_len,int y_len)
{
/* 4350 */
int zz,t,xt,yt,t4,k;
int xlen,ylen;
float z,x,y;

     x=0.;y=0.;

     t4=(int)t3;
     
     k=0; // too many ticks counter

     for( zz = (int)(log10(t1))-1;zz<=(int)(log10(t2))+1;zz++)
     {
         for( t = 0 ;t <= t4 - 2 ;t++)
         {
              z = pow(10,zz) * (1 + (t*10) / t4 );

              if( d == 1 ) { y = z; x = xmin;}
              if( d == 2 ) { x = z; y = ymin;}
              if( d == 3 ) { y = z; x = xmax;}
              if( d == 4 ) { x = z; y = ymax;}
              if( d == 7 ) { x = z; y = 0 ;}
              if( d == 8 ) { y = z; x = 0 ;}


              xt=x_coord(x);
              yt=y_coord(y);

              xlen=x_len;
              ylen=y_len;

              if( scale->ticksType() == TT_TICKS && t == 0) /* longer ticks on powers of 10 */
              {
                   xlen = (3 * x_len)/2;
                   ylen = (3 * y_len)/2;
              }
/* old yu yb defs (was acutally wrong before )
              if((d == 1 || d == 3 || d == 8) && yt > yu && yt < yb) put_ticks(d,xt,yt,xlen,ylen);
*/
              if((d == 1 || d == 3 || d == 8) && yt > (int)yb && yt < (int)yu) put_ticks(d,xt,yt,xlen,ylen);

              if((d == 2 || d == 4 || d == 7) && xt > (int)xl && xt < (int)xr) put_ticks(d,xt,yt,xlen,ylen);
	      
	      k++;
	      if(k > 1000) break;

         }
	 
	 if(k > 1000) break;
     }
}

void GfDraw::put_ticks(int d,int x,int y,int x_len,int y_len)
{
int x0,y0,t5,t6;
static int dd;
int xy[5];

     x0=0;y0=0;

     if( d == 1 ) { x0 = x + x_len; y0 = y; }
     if( d == 2 ) { x0 = x; y0 = y + y_len; }
     if( d == 3 ) { x0 = x - x_len; y0 = y;}
     if( d == 4 ) { x0 = x; y0 = y - y_len;}
     if( d == 7 ) { x0 = x; y0 = y - y_len / 2;  y = y + y_len / 2;}
     if( d == 8 ) { x0 = x - x_len / 2; x = x + x_len / 2;  y0 = y;}

     if(scale->ticksType() != TT_TICKS)  /* alternate drawing direction on grids (for hp plotter) */
     {
          if( dd == 1)
          {
                 t5 = x; t6 = y;  x = x0;  y = y0;
                 x0 = t5;  y0 = t6;  dd = 0 ;
          }
          else dd = 1;
     }
     xy[1] = x0; xy[2] = y0;  xy[3] = x;  xy[4] = y;
     line(2,xy);

}

/*******************************************************************

		PS END ROUTINE
		
********************************************************************/

void GfDraw::done()
{
    switch(device)
    {
	case DEV_PS:
      		if( pdef->encapsulated() == GF_NO)
      		{
            		strcpy(pout, "showpage"); 
			plot_out(pout);
            
#ifdef PSTIMEOUT
            		strcpy(pout, "statusdict begin /waittimeout 30 def end ");
			plot_out(pout);
#endif
      		}
      		sprintf(pout,"%%%%DocumentFonts: %s",fonts_used);
	
		plot_out(pout);
		
	break;
	
	case DEV_QT:
		delete pdef;
		pdef = NULL;
	return;

	default:
		return;

     }
}

int GfDraw::sign(float x)
{
        if(x >= 0.0 )
        {
             return(1);
        }
        else return(-1);
}

void GfDraw::convert(char *data,float x)
{
/*
   used to put axis limit values into string data form

*/
                sprintf(data,"%.4g",x);
}

int GfDraw::checkPixelCoords(int x,int y)
{
	if(x >= xl && x <= xr)
	{
		if(y >= yb && y<= yu)
		{
			return(GF_YES);
		}
	}
	return(GF_NO);
}

/****************************************************************

	DEVICE DEPENDANT ROUTINES
	
	
*****************************************************************/

void GfDraw::line(int n, int *xy)
{
int tx,ty,ii /* ,x,y */;

    switch(device)
    {
	case DEV_PS:
	
	// ps_line

      		tx = xy[1]; 
		ty = xy[2];  
		plot_rotate(&tx, &ty);
		sprintf(pout," n %i %i m ",tx,ty); 
		plot_out(pout);

		for(ii = 2;ii <= n;ii++)
		{
			tx = xy[2 * ii - 1];  
			ty = xy[2 * ii]; 
			plot_rotate(&tx, &ty);
			sprintf(pout,"%i %i l ",tx,ty); 
			plot_out(pout);
		}
		
		strcpy(pout, " s "); 
		plot_out(pout);					
	
	break;
	
	case DEV_QT:

	{
		QPointArray qpts(n);
		
		for(ii=1;ii<=n;ii++)
		{
			qpts.setPoint(ii-1,xy[2 * ii - 1],qth-xy[2 * ii]);
		}
		
		painter->drawPolyline(qpts);

/*		
      		tx = xy[1]; 
		ty = qth-xy[2];  

		for(ii = 2;ii <= n;ii++)
		{
			x = xy[2 * ii - 1];  
			y = qth-xy[2 * ii]; 
			
			painter->drawLine(tx,ty,x,y);
			
#ifdef DEBUG1
			//cout << tx <<" "<< ty <<" "<< x <<" "<< y << "\n";
#endif			
			tx = x;
			ty = y;
		}				
*/	
	break;
	}
	
	default:
	break;
    }

}

void GfDraw::linetype(int t,float patlen)
{
    switch(device)
    {
	case DEV_PS:
	
	/* ps_linetype */
		//solid
		if(t ==  0 )  sprintf(pout," [ ] 0 setdash 0 setlinecap "); 
		//dots
		if(t ==  1 )  sprintf(pout," [ 3 %f ] 0 setdash 1 setlinecap ",patlen*49);
		//dashed
		if(t ==  2 )  sprintf(pout," [ %f ] 0 setdash ",patlen*50); 
		//long short
		if(t ==  3 )  sprintf(pout," [ %f %f %f %f ] 0 setdash 0 setlinecap ",patlen*69,patlen*10,patlen*10,patlen*10);
		//long short short
		if(t ==  4 )  sprintf(pout," [ %f %f %f %f %f %f ] 0 setdash 0 setlinecap ",patlen*40,patlen*10,patlen*10,patlen*10,patlen*10,patlen*10);
		//long dashed
		if(t >=  5 )  sprintf(pout," [ %f %f ] 0 setdash ",patlen*75,patlen*25); 

		// these two are not that nice
		//dash dot
		//if(t ==  3 )  sprintf(pout," [ %f %f %f %f ] 0 setdash 0 setlinecap ",patlen*81,patlen*9,patlen*2,patlen*9);
		//dash dot dot
		//if(t ==  4 )  sprintf(pout," [ %f %f %f %f %f %f ] 0 setdash 0 setlinecap ",patlen*81,patlen*9,patlen*2,patlen*9,patlen*2,patlen*9);
		
		plot_out(pout);				
	
	break;
	
	case DEV_QT:	
      
      		if(t>4) t = 4;
	
		switch(t)
		{
			default:
			case 0:				
				pen.setStyle(SolidLine);
			break;
			case 1:				
				pen.setStyle(DotLine);
			break;
			case 2:				
				pen.setStyle(DashLine);
			break;
			case 3:				
				pen.setStyle(DashDotLine);
			break;
			case 4:				
				pen.setStyle(DashDotDotLine);
			break;
		}
		
		painter->setPen(pen);	
	
	break;
	
	default:
	break;
    }

}

void GfDraw::linewidth(int t)
{
int w;

    switch(device)
    {
	case DEV_PS:

	// ps_setpen
	
      		if(t == 0 )  sprintf(pout," 3 setlinewidth 0 setlinecap ");
      		if(t == 1 )  sprintf(pout," 6 setlinewidth 0 setlinecap ");
      		if(t == 2 )  sprintf(pout," 12 setlinewidth 0 setlinecap "); //default
      		if(t == 3 )  sprintf(pout," 18 setlinewidth 0 setlinecap ");
      		if(t == 4 )  sprintf(pout," 28 setlinewidth 2 setlinecap "); // box
      		if(t >= 5 )  sprintf(pout," 36 setlinewidth 0 setlinecap ");

      		plot_out(pout);
					
	break;
	
	case DEV_QT:
	
		switch(t)
		{
			case 0:
				w = 0;
			break;
			case 1:
				w = 1;
			break;
			case 2:
				w = 1;
			break;
			case 3:
				w = 2;
			break;
			case 4:
				w = 3;
			break;
			
			default:
			case 5:
				w = 4;
			break;
		}

#ifndef UNIX
		if(qt_is_printer == TRUE)
			w = w * 4;
#endif	
		pen.setWidth(w);
		painter->setPen(pen);
	
	
	break;
	
	default:
	break;
    }

}

void GfDraw::symbol(int x, int y, int t)
{
int tx,ty;
float d,dd;

    switch(device)
    {
	case DEV_PS:

		// ps_symbol()

      		tx = x; 
		ty = y;  
		plot_rotate(&tx, &ty);
		
      		strcpy(pout," currentdash pop /t2 exch def [ ] 0 setdash ");
     		plot_out(pout);
		
      		sprintf(pout," n %i %i ",tx,ty);
		
      		if(t == 1 || t == 5 )  strcat(pout, " square ");
      		if(t == 2 || t == 6 )  strcat(pout, " circle ");
      		if(t == 3 || t == 7 )  strcat(pout, " triangle ");
      		if(t == 4 || t == 8 )  strcat(pout, " cone ");
		
      		if(t > 8 ) strcat(pout," cross ");

      		if(t < 5 || t > 8 )
      		{		
             		strcat(pout," s ");
      		}
      		else
      		{
            		strcat(pout," fill ");
      		}
      		plot_out(pout);

      		strcpy(pout," t2 0 setdash "); 
		plot_out(pout);				
	
	break;
	
	case DEV_QT:
	
		d = pdef->symbolSize()*((float)xr - (float)xl) / 50; /* size of the symbols scale with the text */
/*
		if(device == 1 && d < 8 ) d=8;

		if( device ==  2){  t = 0; ulinetype(&t);}
*/
		//linetype(LT_SOLID); // PS does this automatically and restores
				// current linetype
		
#ifdef DEBUG1
		cout << "in symbol\n";
#endif		
		
		if( t < 5)
		{
        		draw_symbol(x,y,t,d);
		}
		else
		{       /* solid symbols */
     			for(dd = d;dd >= 1;dd--)
     			{
        			draw_symbol(x,y,t,dd);
     			}
		}
	
		// put line type back ? have no way to know what it is
		
	break;
	
	default:
	break;
    }

}


void GfDraw::ps_escape_text(char *text)
{
/*
        add escapes to special postscript characters
*/
char temp[100];
int l,i,k;
	l = strlen(text);
	k=0;

	for(i=0;i<l;i++)
	{
        	if(text[i] == '(' || text[i]== ')' || text[i] == '[' || text[i]== ']')
        	{
               		 temp[k]='\\';
                	k=k+1;
        	}
       		 temp[k]=text[i];
        	k=k+1;
	}
	temp[k]='\0';
	strcpy(text,temp);
}


int GfDraw::drawnstrlen(char *text,int rot)
{
int k,i,l;

	// ps_strlen()

    switch(device)
    {
	case DEV_PS:	

/*
        for centered text need length of string without
        special characters, not exact due to small font
        in sub/sup's
*/

        	l = strlen(text);
        	k=0;
        	for(i=0;i<l;i++)
        	{
                	if( text[i] != '{' && text[i]!='}' && text[i]!='^' && text[i]!='_' && text[i]!='$')
                	{
                        	k = k + 1;
                	}
        	}
        	return(k);
	
	
	break;
	
	case DEV_QT:
	

/*
        for centered text need length of string without
        special characters, not exact due to small font
        in sub/sup's
*/

        	l = strlen(text);
        	k=0;
		
		if(rot == 90)
		{
		    i=0;
        	    while(i<l)
        	    {
			switch(text[i])
			{
				case '^':
				case '_':
					i++;
					if(text[i] != '{')
					{
						i++;
					}
					else
					{
						char *p = strchr(&text[i],'}');
						if(p == NULL)
						{
							i = l;
						}
						else
						{
							i = i + p-&text[i]+1;
						}
					}
				break;
				
				case '{':
				case '}':
				case '$':
					i++;
				break;
				
				case '@':
					i++;
					{
						int iv = atoi(&text[i]);
						if(iv > 9) i++;
					}
				break;
				
				default:
					i++;
					k++;
				break;
			}
        	    }
		}
		else
		{
        		for(i=0;i<l;i++)
        		{
                		if( text[i] != '{' && text[i]!='}' && text[i]!='^' && text[i]!='_' && text[i]!='$')
                		{
                        		k = k + 1;
                		}
        		}
		}
        	return(k);
	
	
	break;
	
	default:
	
		return(0);
	break;
    }

}

void GfDraw::text(int tx,int ty,char *tt,int t, float vp)
{
/*
        puts text at tx,ty on the plot rotated by t (0,90,180,270)
	
	vp is the font size to use

        has TeX like formatting for superscripts/subscripts and greek

        ^ makes the next character a superscript
        ^{..} makes the next group of characters superscripts
        _ makes the next character a subscript
        _{..} makes the next group of characters subscripts

        $text$ uses symbol font for text (greek)

        Note for sub/sup $c$ counts as multiple characters
        so need:

        x^{$l$} to get x raised to the lambda

        also can put data point symbols in text

        use @# where # = number of the symbol to show (2-9)

*/
char temp[100],c,frag[100],test[10],cmd[10],rest[100];
int ttx,tty,l,f,k,setsymbol,iv,tx_save,ty_save;

	tx_save = ty_save = 0;

	switch(device)
	{
	
		case DEV_PS:
		
			// ps_text()
		
      			if(pdef->rotatePlot() == GF_YES) t = t + 90;
      			if( t == 360 ) t = 0;

      			if(t == 0 )  sprintf(pout,"%s findfont currentfont ne { %s findfont %f scalefont setfont } if ",psfont[currfont],psfont[currfont],200*vp);
      			if(t == 90 )  sprintf(pout,"%s findfont currentfont ne { %s findfont [0 %f -%f 0 0 0] makefont setfont } if ",psfont[currfont],psfont[currfont],200*vp,200*vp);
      			if(t == 180 )  sprintf(pout,"%s findfont currentfont ne { %s findfont [-%f 0 0 -%f 0 0] makefont setfont } if ",psfont[currfont],psfont[currfont],200*vp,200*vp);
      			if(t == 270 )  sprintf(pout,"%s findfont currentfont ne { %s findfont [0 -%f %f 0 0 0] makefont setfont } if ",psfont[currfont],psfont[currfont],200*vp,200*vp);

      			ps_fontused(currfont);

      			ttx=tx;
      			tty=ty;
      			plot_rotate(&ttx, &tty);
      			sprintf(temp, "%i %i moveto ",ttx,tty);
      			strcat(pout, temp);
      			plot_out(pout);

      		/* have to set sub/sup offsets for text angle */

      			if( t == 0 )
      			{
      			  strcpy(pout,"/dropy fheight drop mul def"); plot_out(pout);
      			  strcpy(pout,"/dropx fheight 0.0 mul def"); plot_out(pout);
     			  strcpy(pout,"/mdropx dropx -1 mul def"); plot_out(pout);
     			  strcpy(pout,"/mdropy dropy -1 mul def"); plot_out(pout);
      			  strcpy(pout,"/raisey fheight raise mul def"); plot_out(pout);
       			  strcpy(pout,"/mraisey raisey -1 mul def"); plot_out(pout);
      			  strcpy(pout,"/raisex fheight 0.0 mul def"); plot_out(pout);
       			  strcpy(pout,"/mraisex raisex -1 mul def"); plot_out(pout);
      			}
      			if( t == 270 )
      			{
     			   strcpy(pout,"/dropy fheight 0.0 mul def"); plot_out(pout);
      			   strcpy(pout,"/dropx fheight drop mul def"); plot_out(pout);
     			   strcpy(pout,"/mdropx dropx -1 mul def"); plot_out(pout);
     			   strcpy(pout,"/mdropy dropy -1 mul def"); plot_out(pout);
    			   strcpy(pout,"/raisey fheight 0.0 mul def"); plot_out(pout);
     			   strcpy(pout,"/mraisey raisey -1 mul def"); plot_out(pout);
     			   strcpy(pout,"/raisex fheight raise mul def"); plot_out(pout);
     			   strcpy(pout,"/mraisex raisex -1 mul def"); plot_out(pout);
      			}
      			if( t == 180 )
      			{
      			  strcpy(pout,"/dropy fheight -1 drop mul mul def"); plot_out(pout);
     			   strcpy(pout,"/dropx fheight 0.0 mul def"); plot_out(pout);
     			   strcpy(pout,"/mdropx dropx -1 mul def"); plot_out(pout);
     			   strcpy(pout,"/mdropy dropy -1 mul def"); plot_out(pout);
    			    strcpy(pout,"/raisey fheight -1 raise mul mul def"); plot_out(pout);
     			   strcpy(pout,"/mraisey raisey -1 mul def"); plot_out(pout);
     			   strcpy(pout,"/raisex fheight 0.0 mul def"); plot_out(pout);
     			   strcpy(pout,"/mraisex raisex -1 mul def"); plot_out(pout);
      			}
      			if( t == 90 )
      			{
     			   strcpy(pout,"/dropy fheight 0.0 mul def"); plot_out(pout);
     			   strcpy(pout,"/dropx fheight -1 drop mul mul def"); plot_out(pout);
     			   strcpy(pout,"/mdropx dropx -1 mul def"); plot_out(pout);
     			   strcpy(pout,"/mdropy dropy -1 mul def"); plot_out(pout);
     			   strcpy(pout,"/raisey fheight 0.0 mul def"); plot_out(pout);
     			   strcpy(pout,"/mraisey raisey -1 mul def"); plot_out(pout);
     			   strcpy(pout,"/raisex fheight -1 raise mul mul def"); plot_out(pout);
     			   strcpy(pout,"/mraisex raisex -1 mul def"); plot_out(pout);
      			}

        		setsymbol = 0;

        		l = strlen(tt);

        		strcpy(test,"$_^}@");    /* special chars to trap for */

        		strcpy(rest, tt);

        		ps_escape_text(rest);

        		strcpy(cmd,"show");

        		do
        		{
                		k = strcspn(rest,test); /* find location of next special character */

               			if( k == 0 )    /* if first character don't need to show frag */
                		{
                       			 if(rest[0] == '}' )    /* no action needed, strip it */
                        		 {
                                		frag[0]=rest[0];
                                		frag[1]='\0';
                                		strcpy(temp,&rest[1]);
                                		strcpy(rest,temp);
                        		}

                		}
                		else
                		{     /* have some characters to show with current cmd */

                        		strcpy(frag,rest);
                        		frag[k]='\0';  /* get left part */
                        		strcpy(temp,&rest[k]); /* get right part */
                       			 strcpy(rest,temp);

                        		sprintf(pout,"(%s) %s ",frag,cmd); plot_out(pout);
                		}

               			 if(rest[0] == '$' ) /* change font to symbol or back */
                		{
                       		 	if(setsymbol == 0)
                        		{
                                		f = PS_SYMBOLFONT;
                                		setsymbol = 1;
                        		}
                        		else
                        		{
                                		f = currfont;
                                		setsymbol = 0;
                        		}

      					if(t == 0 ) sprintf(pout,"%s findfont currentfont ne { %s findfont %f scalefont setfont } if ",psfont[f],psfont[f],200*vp);
     					if(t == 90 ) sprintf(pout,"%s findfont currentfont ne { %s findfont [0 %f -%f 0 0 0] makefont setfont } if ",psfont[f],psfont[f],200*vp,200*vp);
      					if(t == 180 ) sprintf(pout,"%s findfont currentfont ne { %s findfont [-%f 0 0 -%f 0 0] makefont setfont } if ",psfont[f],psfont[f],200*vp,200*vp);
      					if(t == 270 ) sprintf(pout,"%s findfont currentfont ne { %s findfont [0 -%f %f 0 0 0] makefont setfont } if ",psfont[f],psfont[f],200*vp,200*vp);

                       			plot_out(pout);

                        		ps_fontused(f);

                       			strcpy(temp,&rest[1]);
                       			strcpy(rest,temp);
                 		}
                		else
                		{      /* don't lose the cmd if just changing fonts */
                       			strcpy(cmd,"show"); /* reset command to show */
                		}

                		if( rest[0] == '@') /* put a symbol here */
                		{
                        		iv = atoi(&rest[1]); /* get symbol number */
                        		iv = iv - 1;
                        		strcpy(pout," currentdash pop /t2 exch def [ ] 0 setdash ");
                        		plot_out(pout);

                        /* need currentpoint to draw symbol at and to restore location */
                        		strcpy(pout," currentpoint raisex raisey rmoveto currentpoint n ");
                        		if(iv == 1 || iv == 5 )  strcat(pout, " square ");
                        		if(iv == 2 || iv == 6 )  strcat(pout, " circle ");
                        		if(iv == 3 || iv == 7 )  strcat(pout, " triangle ");
                        		if(iv == 4 || iv == 8 )  strcat(pout, " cone ");
                        		if(iv > 8 ) strcat(pout," cross ");

                        		if(iv < 5 || iv > 8 )
                        		{	
                                		strcat(pout," s ");
                        		}
                        		else
                        		{
                                		strcat(pout," fill ");
                        		}
                        		plot_out(pout);

                        /* moveto gets us back to old current point */

                        		strcpy(pout," t2 0 setdash moveto "); plot_out(pout);

                        		rest[0]=' ';  /* leave spaces for symbol */
                        		rest[1]=' ';

                        		if( iv > 8)  /* means was @10 so need extra character removed */
                        		{
                                		rest[2]=' ';
                                		strcpy(temp,&rest[1]);
                                		strcpy(rest,temp);
                         		}

                		}
	
                		if( rest[0] == '_')  /* subscript */
                		{
                        		if( rest[1] == '{' )   /* is it single character ? */
                        		{
                                		strcpy(cmd,"subshow");
                                		strcpy(temp,&rest[2]);
                                		strcpy(rest,temp);
                        		}
                        		else
                        		{
                                		c = rest[1];
                                		sprintf(pout,"(%c) subshow ",c); plot_out(pout);
                                		strcpy(temp,&rest[2]);
                                		strcpy(rest,temp);
                        		}
                		}

                		if( rest[0] == '^') /* superscript */
                		{
                        		if( rest[1] == '{' )  /* is it multi character ? */
                        		{	
                                		strcpy(cmd,"supshow");
                                		strcpy(temp,&rest[2]);
                                		strcpy(rest,temp);

                        		}
                        		else
                        		{
                                		c = rest[1];
                                		sprintf(pout,"(%c) supshow ",c); plot_out(pout);
                                		strcpy(temp,&rest[2]);
                                		strcpy(rest,temp);
                        		}
                		}

                		l = strlen(rest); /* how much is left ? */

        		}
        		while ( l > 0 );  /* go till none left */
		
		break;
	
		case DEV_QT:		
		
		setQtFont(currfont,vp); // need metrics back
				
		if(t == 90)
		{			
			painter->translate(tx,qth-ty);
			painter->rotate(-90);
			tx_save = tx;
			ty_save = qth-ty;
			tx = 0;
			ty = qth;
		}
				
		if(t == 0 || t == 90)
		{	
			//setQtFont(currfont,vp);
	
			//painter->drawText(tx,qth-ty,tt);
			
			QPoint text_pos(tx,qth-ty);
			
			//drawQtText(&text_pos,tt,currfont,vp);
			
			setsymbol = 0;

        		l = strlen(tt);

        		strcpy(test,"$_^}@");    /* special chars to trap for */

        		strcpy(rest, tt);
			
			float fsize,small_size;
			
			fsize = vp;
			small_size = 0.8*vp;
			
			int font_index,supsub_flag;
			
			font_index = currfont;
			
			supsub_flag = 0; 
			
			const int SUB = 1;
			const int SUPER = 2;
			
			const QPoint sub_drop(0,(int)(12.*vp*.25));
			const QPoint sup_raise(0,-(int)(12.*vp*.6));

        		do
        		{
                		k = strcspn(rest,test); /* find location of next special character */

               			if( k == 0 )    /* if first character don't need to show frag */
                		{
                       			 if(rest[0] == '}' )    /* no action needed, strip it */
                        		 {
                                		frag[0]=rest[0];
                                		frag[1]='\0';
                                		strcpy(temp,&rest[1]);
                                		strcpy(rest,temp);
						
						fsize = vp;
						if(supsub_flag == SUPER)
						{
							text_pos = text_pos - sup_raise;
						}
						if(supsub_flag == SUB)
						{
							text_pos = text_pos - sub_drop;
						}
							
						supsub_flag = 0;
		               		}

                		}
                		else
                		{     /* have some characters to show with current cmd */

                        		strcpy(frag,rest);
                        		frag[k]='\0';  /* get left part */
                        		strcpy(temp,&rest[k]); /* get right part */
                       			strcpy(rest,temp);
					
					if(supsub_flag == SUB)
					{
						text_pos = text_pos + sub_drop;
					}
					if(supsub_flag == SUPER)
					{
						text_pos = text_pos + sup_raise;
					}
					
					drawQtText(&text_pos,frag,font_index,fsize);

                        		//sprintf(pout,"(%s) %s ",frag,cmd); plot_out(pout);
                		}

               			if(rest[0] == '$' ) /* change font to symbol or back */
                		{
                       		 	if(setsymbol == 0)
                        		{
                                		font_index = PS_SYMBOLFONT;
                                		setsymbol = 1;
                        		}
                        		else
                        		{
                                		font_index = currfont;
                                		setsymbol = 0;
                        		}

                      			strcpy(temp,&rest[1]);
                       			strcpy(rest,temp);
                 		}

                		if( rest[0] == '@') /* put a symbol here */
                		{
                        		iv = atoi(&rest[1]); /* get symbol number */
                        		iv = iv - 1;
					
					// show symbol here 
					float d = pdef->symbolSize()*((float)xr - (float)xl) / 50; /* size of the symbols scale with the text */
		
					if( iv < 5)
					{
        					draw_symbol(text_pos.x(),qth-text_pos.y()+d,iv,d);
					}
					else
					{       /* solid symbols */
						float dd;
					
     						for(dd = d;dd >= 1;dd--)
     						{
        						draw_symbol(text_pos.x(),qth-text_pos.y()+d,iv,dd);
     						}
					}
					
                        		rest[0]=' ';  /* leave spaces for symbol */
                        		rest[1]=' ';

                        		if( iv > 8)  /* means was @10 so need extra character removed */
                        		{
                                		rest[2]=' ';
                                		strcpy(temp,&rest[1]);
                                		strcpy(rest,temp);
                         		}

                		}
	
                		if( rest[0] == '_')  /* subscript */
                		{
                        		if( rest[1] == '{' )   /* is it single character ? */
                        		{
                                		//strcpy(cmd,"subshow");
						
						fsize = small_size;
						supsub_flag = SUB;
						
                                		strcpy(temp,&rest[2]);
                                		strcpy(rest,temp);
                        		}
                        		else
                        		{
                                		c = rest[1];
                                		//sprintf(pout,"(%c) subshow ",c); plot_out(pout);
						
						temp[0]=c;
						temp[1]=0;
						
						text_pos = text_pos + sub_drop;
						
						drawQtText(&text_pos,temp,font_index,small_size);
						
						text_pos = text_pos - sub_drop;
						
                                		strcpy(temp,&rest[2]);
                                		strcpy(rest,temp);
                        		}
                		}

                		if( rest[0] == '^') /* superscript */
                		{
                        		if( rest[1] == '{' )  /* is it multi character ? */
                        		{	
                                		//strcpy(cmd,"supshow");
						
						fsize = small_size;
						supsub_flag = SUPER;
						
                                		strcpy(temp,&rest[2]);
                                		strcpy(rest,temp);

                        		}
                        		else
                        		{
                                		c = rest[1];
						
						temp[0]=c;
						temp[1]=0;
						
						text_pos = text_pos + sup_raise;
						drawQtText(&text_pos,temp,font_index,small_size);
						
						text_pos = text_pos - sup_raise;
						
                                  		strcpy(temp,&rest[2]);
                                		strcpy(rest,temp);
                        		}
                		}

                		l = strlen(rest); /* how much is left ? */

        		}
        		while ( l > 0 );  /* go till none left */
			
		}
		
		if(t == 90)
		{
			painter->rotate(90);
			painter->translate(-tx_save,-ty_save);
		}
		setQtFont(currfont,vp); // need metrics back
		
		break;
	
	
		default:
	
		break;
	}
	
}

void GfDraw::drawQtText(QPoint *pos,char *text,int font_index,float size)
{
/*
	postscript like function
	
	updates pos to point to location after text at which
	printing should continue
*/
	setQtFont(font_index,size);

	painter->drawText(*pos,text);
	
	QFontMetrics fm = painter->fontMetrics();
	
	QPoint offset(fm.width(text,-1),0);
	
	*pos=*pos+offset;
}
	

void GfDraw::setQtFont(int font_index, float size)
{
/*
	parses the font settings from the PS names
*/
QString fname(psfont[font_index]+1);
bool italics;
int weight,p_size;
			
	p_size =(int)( size*12.);
			
	if(fname.contains("Italic") == TRUE || fname.contains("Oblique") == TRUE)
	{
		italics = TRUE;
	}
	else
	{
		italics = FALSE;
	}
			
	if(fname.contains("Bold") == TRUE)
	{
		weight = QFont::Bold;
	}
	else
	{
		weight = QFont::Normal;
	}
			
	if(fname.contains("-") == TRUE)
	{	
		fname.remove(fname.find('-'),50);
	}						
			
	QFont font(fname,p_size,weight,italics);
	painter->setFont(font);
}


void GfDraw::ps_fontused(int f)
{
/*

  stores the current font name in fontsused for encap PS
  if it is not already there.
*/
char *temp;


        temp = &psfont[f][0];
	
	if(fonts_used == NULL )
	{
		fonts_used=(char *)malloc(strlen(temp)+1);
		strcpy(fonts_used,temp);
		return;
	}

        if( strstr(fonts_used, temp) == NULL)
        {
		fonts_used=(char *)realloc(fonts_used,strlen(fonts_used)+strlen(temp)+1);
		
		if(fonts_used == NULL)
		{
			printf("out of memory in gfdraw\n");
			exit(-1);
		}
	
            	strcat(fonts_used," ");
            	strcat(fonts_used,temp);
        }

}

void GfDraw::setcolor(int t)
{

int r,g,b;
float fr,fg,fb;

	r=0;g=0;b=0; 

     // colors used for PS printing, fully saturated to avoid dithering

         if(t == 0 )/* black */
         {
                 r=0;g=0;b=0; /* black */
         }

next_color:

         if( t == 1)
         {
               	r=0;g=0;b=255; /* blue */
         }
         if( t == 2)
         {
                 r=0;g=255;b=0;/* green */
         }
         if( t == 3)
         {
                 r=255;g=0;b=0; /* red */
         }
         if( t == 4)
         {
                 r=0;g=255;b=255;/* cyan */
         }
         if( t == 5)
         {
                 r=255;g=0;b=255;/* magenta */
         }
         if( t == 6)
         {
                 r=139;g=69;b=19;/* saddle brown */
/*                 r=255;g=255;b=0;*/ /* yellow */
         }
         if( t == 7)
         {
                 r=255;g=255;b=255;/* white */
         }

         if(t > 7)
	{ 
		t = t - 7; 
		goto next_color;
	}
		
    switch(device)
    {
	case DEV_PS:
	
         	if(t == 0 )/* black */
         	{
                 	strcpy(pout," 0 setgray ");
                 	plot_out(pout);
                 	return;
         	}


         	/* postscript color range is 0-1 */

         	fr=(float)r/255.;
         	fb=(float)b/255.;
         	fg=(float)g/255.;

        	sprintf(pout," %f %f %f setrgbcolor ",fr,fg,fb);
        	plot_out(pout);

				
	
	break;				
	
	case DEV_QT:
	
		{	
			QColor qc(r,g,b,QColor::Rgb); 
		
			pen.setColor(qc);	
	
			painter->setPen(pen);		
		}
		
	break;
	
	default:
	break;
    }

}


void GfDraw::plot_out(char *out)
{

// should never be called by QT paint routines

	if(device == DEV_PS)
	{
		strcat(out,"\n");
		qfile->writeBlock(out,strlen(out));
	}
}

void GfDraw::plot_rotate(int *tx,int *ty)
{
/*
13697 REM
13698 REM    APPLY ROTATION MAP IF rotp = 'Y'
13699 REM
*/
int tt;
        if( pdef->rotatePlot() == GF_YES )
        {
              tt = 10300 - *ty; *ty = *tx;  *tx = tt;
        }
}
