#include <stdio.h>
#include <string.h>
#include "gfcommon.h"


int getintval(char *key,char *line,int *v)
{
char *p;
	if(strstr(line,key) == NULL)
		return(GF_BAD);
		
	p = strchr(line,':');
	
	if(p == NULL) 
		return(GF_BAD);
		
	p++;
	
	*v=atoi(p);
	
	return(GF_OK);
	
}

int getcharval(char *key,char *line,char *v)
{
char *p;
	if(strstr(line,key) == NULL)
		return(GF_BAD);
		
	p = strchr(line,':');
	
	if(p == NULL) 
		return(GF_BAD);
	
	p=p+2;// assume there is a space after the :
	
	*v=*p;
	
	return(GF_OK);
	
}

int getstrval(char *key,char *line,char **v)
{
char *p;
	if(strstr(line,key) == NULL)
		return(GF_BAD);
		
	p = strchr(line,':');
	
	if(p == NULL) 
		return(GF_BAD);
	
	p=p+2;// assume there is a space after the :
	
	while(p[strlen(p)-1] == '\n')
	{
		p[strlen(p)-1] = 0;
	}
	
	*v=p;
	
	return(GF_OK);
	
}

int getfloatval(char *key,char *line,float *v)
{
char *p;
	if(strstr(line,key) == NULL)
		return(GF_BAD);
		
	p = strchr(line,':');
	
	if(p == NULL) 
		return(GF_BAD);
		
	p++;
	
	*v=atof(p);
	
	return(GF_OK);
	
}

void strmalloc(char **s,int len)
{
	if(len <= 0)
		return;
	
	*s = (char *)malloc(len+1);
	if( *s == NULL)
	{
		printf("out of memory in strmalloc\n");
		exit(-1);
	}
}

void winFixExpFmt(char *text)
{
/*
	reduces the exponent field to E+xx from E+xxx
	
*/

char *p;

	p = strchr(text,'E');
	
	if(p != NULL && strlen(p) == 5)
	{
		p++;// now points at sign
		
		p++;// now points at first exponent digit
		
		*p=*(p+1); //first exponent digit
		p++;
		*p=*(p+1); //second exponent digit
		p++;
		*p=*(p+1); //trailing null
		
		if( *p != '\0' ) // initial test
		{
			cout<<"oops in winFixExpFmt\n";
			cout<<text<<"\n";
			exit(-1);
		}				
	}
}
